#!/bin/sh

ulimit -m 524288 -t 10

if grep "^$(basename $0)$" ${SRCDIR}/unexpected.list &>/dev/null; then
  UNEXPECTED=1
else
  UNEXPECTED=0
fi

if test "x$VERBOSE" = x; then
  export VERBOSE=0
fi

out="$0.out"
err="$0.err"

test -w $out && rm -f $out
test -w $err && rm -f $err

if test $VERBOSE -le 0; then
  out="/dev/null"
  err="/dev/null"
fi

exec > $out 2> $err

leave(){
  test \( $1 -eq 0 -a $UNEXPECTED -eq 0 \) -o \( $1 -ne 0 -a $UNEXPECTED -ne 0 \)
  local exit_code=$?
  if test $1 -eq 77 || test $exit_code -eq 0; then
    test "$out"="/dev/null" || rm -f $out
    test "$err"="/dev/null" || rm -f $err
  else
    test -r cxx-out && echo "cxx:" && cat cxx-out
    test -r dxx-out && echo "dxx:" && cat dxx-out
  fi
  test -w cxx-out && rm -f cxx-out
  test -w dxx-out && rm -f dxx-out
  test $1 -eq 77 && exit 77
  exit $exit_code
}
